#!/usr/bin/perl -w
(my @fics) = <*.tree>;
####################
open(IN, $ARGV[0]);
my @samples;
my %MET;
while(<IN>)
{
        (my @tab) = split("\t", $_);
        chomp($MET{$tab[0]} = $tab[1]);
        push(@samples,$tab[0]);
}
close IN;
####################
my $out = 'HGTs_Gp'.$ARGV[1].'_m'.$ARGV[2].'_B'.$ARGV[3].'_D'.$ARGV[4].'_IMD_'.$ARGV[5];
open(OUT,">$out");
print OUT "GP\tOG\tComposition\tNb gene\tTotal\tBootstrap\tDist\tIMD\tSubtree\n";
####################
my $nbfics = @fics;
my $cc = 1;
foreach my $f(@fics)
{
        ####################        
        if(-s $f)
        {
               my $r = sprintf("%.4f", $cc / $nbfics) * 100;
               if( ($r % 10) == 0)
               {
                        print "# $r % done #\n";
               }
               $cc ++;
               open(TREE, $f);
               (my $OG) = ($f =~ /(.*)\.tree/);
               (my @tree) = <TREE>;
               close TREE;
               (my @totsp) = ($tree[0] =~/(\w+)_/g);
               my $nbtot = @totsp;
               #print "\n\n@totsp\n\n";
               my $composite;
               foreach my $e(@totsp)
               {
                    $composite .= $MET{$e};
               }
               if($composite =~ /$ARGV[1]/)
               {
                       if($composite =~ /^(.)\1+$/)
                       {
                             chomp($tree[0]);
                             (my @dist) = ($tree[0]=~/\:(\d+\.\d+)/g);
                             my %rep;
                             foreach my $e(@totsp)
                             {
                                        $rep{$e} ++;
                             }
                             my $dif = 0;
                             foreach my $k(keys(%rep))
                             {
                                        $dif ++;
                             }
                             my $sum = 0;
                             if($dif > 1)
                             {
                                     foreach my $d(@dist)
                                     {
                                               $sum += $d;
                                     }
                                     my $med = $sum / $nbtot;	
                                     print OUT "$ARGV[1]\t$OG\tUniq\t$nbtot\t$nbtot\tNA\tNA\t$med\t$tree[0]\n";
                             }
                       }
                       else
                       {
                               my $popen = 0;
                               my $pclose = 0;
                               while($tree[0] =~ /\(/g)
                               {
                                        $popen ++;
                               }
                               while($tree[0] =~ /\)/g)
                               {
                                        $pclose ++;
                               }
                               my $l = length($tree[0]);
                               ####################
	                       if($popen == $pclose)
                               {
		                       	my @monos;
		                       	my @GPs;
		                       	(my @sp) = split("",$tree[0]);
			                for(my $i = 0; $i < $l -1; $i ++)
			                {
			                        my $sub;
			                        if($sp[$i] eq '(')
			                        {
			                                $sub .= $sp[$i];
			                                for(my $j = $i +1; $j < $l; $j ++)
			                                {
			                                        if($sp[$j] eq ')')
			                                        {
			                                                 $sub .= $sp[$j];
			                                                 push(@GPs,$sub);
		                                                }
		                                                else
		                                                {
		                                                       $sub .= $sp[$j];
	                                                        } 
                                                        }
                                                }
                                        }
                                        my %boots;
                                        my %dists;
                                        foreach my $g(@GPs)
                                        {
                                              my $po = 0;
                                              my $pc = 0;
                                              my $comma = 0;
                                              while($g =~ /\(/g)
                                              {
                                                       $po ++;
                                              }
                                              while($g =~ /\)/g)
                                              {
                                                       $pc ++;
                                              }
                                              while($g =~ /,/g)
                                              {
                                                      $comma ++;
                                              }
                                              $comma ++;
                                              my $ll = length($g);
                                              if( ($po == $pc) and ($comma >= $ARGV[2]) and ($comma < $nbtot) )
                                              {
                                                        my $tosearch = $g;
                                                        $tosearch =~ s/([^\w])/\\$1/g;
                                                        if($tree[0]=~/$tosearch(\d+\.\d+)/)
                                                        {
                                                                (my $boot) = ($tree[0] =~ /$tosearch(\d+\.\d+)/);
                                                                my $tosearch2 = $tosearch.$boot;
                                                                (my $dist) = ($tree[0] =~ /$tosearch2:(\d+\.\d+)/);
                                                                if( ($boot >= $ARGV[3]) and ($dist >= $ARGV[4]) )
                                                                {
                                                                        push(@monos,$g);
                                                                }
                                                                $boots{$g} = $boot;
                                                                $dists{$g} = $dist; 
                                                        }
                                                        else
                                                        {
                                                              (my $dist) = ($tree[0] =~ /$tosearch:(\d+\.\d+)/);
                                                              if($dist >= $ARGV[4])
                                                              {
                                                                        push(@monos,$g);
                                                              }
                                                              $boots{$g} = 'NA';
                                                              $dists{$g} = $dist;
                                                        }
                                              }
                                        }
                                        ####################
		                        foreach my $e(@monos)
	                                {
	                                        my $treemod = $tree[0];
	                                        $treemod =~ s/([^\w])/\\$1/g;
	                                        my $m = $e;
	                                        $m =~ s/([^\w])/\\$1/g;
	                                        (my @sps) = ($e=~/(\w+)_/g);
	                                        my $lsp = @sps;
	                                        $lsp --;
	                                        (my @dist) = ($e=~/\:(\d+\.\d+)/g);
                                                (my $pretree) = ($tree[0] =~ /(.*)$m/);
                                                (my $posttree) = ($tree[0] =~ /$m(.*)/);
                                                my $ext = $pretree.'#'.$posttree;
                                                (my @sp_ext) = ($ext =~/(\w+)_/g);
	                                        my $sum = 0;
	                                        my $nbc = 0;
	                                        while($e =~ /,/g)
                                                {
                                                      $nbc ++;
                                                }
                                                $nbc ++;
	                                        foreach my $d(@dist)
	                                        {
	                                                $sum += $d;
                                                }
                                                my $med = $sum / @sps;	                        
	                                        my $lgp;
	                                        foreach my $s(@sps)
	                                        {
	                                                $lgp .= $MET{$s};
                                                }
                                                my $lgp_ext;
	                                        foreach my $s(@sp_ext)
	                                        {
	                                               $lgp_ext .= $MET{$s};
                                                }
                                                print "\t\tMono : $lgp\n\t\tExt  : $lgp_ext\tMed : $med\n\n";
                                                my %rep;
                                                foreach my $e(@sps)
                                                {
                                                        $rep{$e} ++;
                                                }
                                                my $dif = 0;
                                                foreach my $k(keys(%rep))
                                                {
                                                        $dif ++;
                                                }           
                                                if( ($lgp =~ /^(.)\1+$/) and ($med <= $ARGV[5]) and ($lgp_ext !~ /$ARGV[1]/) and ($dif > 1) )
                                                {
                                                        print OUT "$ARGV[1]\t$OG\tShared\t$nbc\t$nbtot\t$boots{$e}\t$dists{$e}\t$med\t$e\n";
                                                }
                                        }
                                }
                        }
                }
	}
}
close OUT;
exit;
